; $Id: dcs_choose_conditions.pro,v 1.3 2002/07/13 20:30:59 john Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
pro dcs_choose_conditions_handler,event
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,get_uvalue=pstate,/no_copy
bs=(*pstate).bs
okbut=(*pstate).okbut
wlbl=(*pstate).wlbl
ptr=(*pstate).ptr
assignments=*ptr
;
nf=n_elements(assignments)
etag=event.id
;
if (etag eq okbut) then begin
	listing=where(assignments eq 0)
	unset=n_elements(listing)
	checksum=fix(total(listing))
	if (checksum ne -1) then begin
		case unset of
			1: warning='  NB: 1 row does not have a button set.  '
			else: warning='  NB:'+strcompress(unset)+' rows do not have a button set.  '
		endcase
		widget_control,wlbl,set_value=warning
		widget_control,event.top,set_uvalue=pstate,/no_copy
	endif else widget_control,event.top,/destroy
	return
endif
;
eval=event.value
etag=where(etag eq bs)
assignments[etag]=eval+1
*(*pstate).ptr=assignments
widget_control,event.top,set_uvalue=pstate,/no_copy
;
end


;************************************************************************************************
pro dcs_choose_conditions,dcs_base,conditions,fnames,assignments
;************************************************************************************************
;
compile_opt strictarr
;
nf=n_elements(fnames)
;
;dcs_sysdep,fonts=fonts
;
ncon=n_elements(conditions);
base=widget_base(title='Assign a condition to each data file.',$
	group_leader=dcs_base,/modal,/col)
	bg=intarr(nf)
	bs=intarr(nf)
	lb=intarr(nf)
	for i=0,nf-1 do begin
		bg[i]=widget_base(base,/row)
		bs[i]=cw_bgroup(bg[i],conditions,/row,/exclusive)
		lb[i]=widget_label(bg[i],value=fnames[i])
	endfor
	choices=widget_base(base,/row)
	okbut=widget_button(choices,value="OK")
	wlbl=widget_label(choices,/dynamic_resize,/align_right,value="");,font=fonts[0])
;
dave_position_tlb,base
widget_control,base,/realize
;
for i=0,nf-1 do begin
	if (assignments[i] gt 0) then $
	widget_control,long(bs[i]),set_value=assignments[i]-1
endfor
;
ptr=ptr_new(assignments)
;
state={bs:bs,okbut:okbut,wlbl:wlbl,ptr:ptr}
widget_control,base,set_uvalue=ptr_new(state),/no_copy
;
xmanager,'dcs_choose_conditions',base,event_handler='dcs_choose_conditions_handler'
;
assignments=*ptr
ptr_free,ptr
;
end
