; $Id: dcs_sort_by.pro,v 1.3 2002/07/13 20:14:58 john Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
pro DCS_sort_by,inarr,outarr,col=col,row=row,error
;************************************************************************************************
;
compile_opt strictarr
;
; Given a 2-d input array "inarr" this routine returns an output array "outarr" sorted by column
; "col">0 if "row"=0 or by row "row">0 if "col"=0.
error=0
sizing=size(inarr)
if (sizing[0] ne 2) then begin
	error=1
	return
endif
ncol=sizing[1]; (first index)
nrow=sizing[2]; (second index)
nrc=nrow*ncol
if (col gt ncol or row gt nrow) then  begin
	error=2
	return
endif
if (col gt 0 and row eq 0) then begin
	outarr=inarr[transpose(sort(inarr[col-1,*])*ncol#transpose(intarr(ncol)+1))+indgen(nrc) mod ncol]
	return
endif
if (row gt 0 and col eq 0) then begin
	outarr=inarr[sort(inarr[*,row-1])#transpose(intarr(nrow)+1)+indgen(nrc)/ncol*ncol]
	return
endif
error=3
return
end