;$Id: dave_dialog_pickfile.pro,v 1.2 2002/04/25 13:29:35 jmspark Exp $
;
; DAVE_Dialog_Pickfile is a wrapper for dialog_pickfile.
; It changes the current directory to the one
;  that the picked file is located
;  and sets !dave_defaults accordingly.
;
function dave_dialog_pickfile $
	, read = read $
	, write = write $
	, _extra = _extra


	files = dialog_pickfile( read = read, write = write, _extra = _extra )
	file = files[0]
	if file eq '' then return, file

	; Call davesysvars to make sure !windows & !delimiters are present.
	davesysvars
	defsysv, '!dave_defaults', exists=exists
	if exists then exists = exists * ptr_valid( !dave_defaults )

	match = '.*' + !delimiter
	if !windows then match = match + !delimiter

	dir = stregex( file, match, /extract )
	message, 'Chaning directory to ' + dir, /continue
	cd, dir

	if exists then begin

		if keyword_set( read ) then begin

			(*!dave_defaults).datDir = dir

		endif

		if keyword_set( write ) then begin

			(*!dave_defaults).workDir = dir

		endif

	endif

	return, files

end