;$Id: array_points2histo.pro,v 1.1 2002/04/22 13:48:57 jmspark Exp $
; INPUT must be strictly 2D arrays.

pro array_points2histo_x $
	; INPUT
	, in $
	; OUTPUT
	, out

	size_in = size( in, /dimension )
	n = size_in[ 0 ]
	if n eq 0 then n = 1 ; Point -> Vector

	size_out = size_in
	size_out[ 0 ] = n + 1

	out = dblarr( size_out )
	out[0, *] = in[0, *]
	out[n, *] = in[n-1, *]

	for i = 1, n - 1 do out[i, *] = ( in[i-1, *] + in[i, *] ) / 2d

end

pro array_points2histo_y $
	; INPUT
	, in $
	; OUTPUT
	, out


	in = [ [ in ] ]
	size_in = size( in, /dimension )

	if n_elements( size_in ) lt 2 then size_in = [ size_in, 1 ]
	n = size_in[ 1 ]

	size_out = size_in
	size_out[ 1 ] = n + 1

	out = dblarr( size_out )

	out[*, 0] = in[*, 0]
	out[*, n] = in[*, n-1]

	for i = 1, n - 1 do out[*, i] = ( in[*, i-1] + in[*, i] ) / 2d

end

pro array_points2histo $
	, z, x, y

	zsize = size( z )
	nx = zsize[1]
	ny = zsize[2]

if n_elements( x[*, 0] ) eq nx then begin
	array_points2histo_x, x, xp
	array_points2histo_x, y, yp
endif else begin
	xp = x
	yp = y
endelse

if n_elements( x[0, *] ) eq ny then begin
	array_points2histo_y, xp, x
	array_points2histo_y, yp, y
endif else begin
	x = xp
	y = yp
endelse

end